Subject: bug#6026: 23.1.96; Cursor drawing problems with the Khmer script

From: Jason Rumney <[email-masked]>
Date: Thu, 29 Apr 2010 16:01:12 +0800

On 28/04/2010 06:29, Juanma Barranquero wrote:
> On Tue, Apr 27, 2010 at 18:14, Jason Rumney<[email-masked]>  wrote:
> FWIW, on Windows 7 Home I get four matches, and I haven't installed
> any Khmer support (at least, not directly; perhaps some product?).
>
> #<font-entity uniscribe outline DaunPenh nil iso10646-1 normal normal
> normal 0 nil 0 nil ((:format . opentype) (:script khmer latin))>
> #<font-entity uniscribe outline Khmer\ UI sans iso10646-1 bold normal
> normal 0 nil 0 nil ((:format . opentype) (:script symbol khmer
> latin))>
> #<font-entity uniscribe outline Khmer\ UI sans iso10646-1 normal
> normal normal 0 nil 0 nil ((:format . opentype) (:script symbol khmer
> latin))>
> #<font-entity uniscribe outline MoolBoran sans iso10646-1 normal
> normal normal 0 nil 0 nil ((:format . opentype) (:script symbol khmer
> latin))>
>    

These all look like Khmer specific fonts to me. I get one match on 
Windows XP SP3, which is for Khmer OS System, a font I manually installed.

>> So the following might be a better font spec, at least for Windows:
>>
>> (font-spec :registry "iso10646-1" :otf '(khmr nil
>>                                         (pref blwf abvf pstf pres blws
>>                                          abvs psts clig)))
>>
>>      
> That gets me the same list.
>    

Me too, but it filters out the fonts that Eli has which appear not to 
fully support Khmer OTF tables, but contain enough support to match the 
current font-spec.  This may be part of the problem Eli is seeing, but I 
also see display corruption (cursor being left behind) when moving 
backwards through Khmer text, so there is probably also a problem with 
the version of usp10.dll on Windows XP.

> As for the bug, I don't see it either. Moving the cursor on the Khmer
> list, the cursor appears as wide as the character it is upon (i.e., is
> very small but perfectly visible over U+179A KHMER LETTER RO), and
> neither forward nor backward movement shows anything unexpected.
>    

This is different than GNU/Linux with libotf and m17n. There, the cursor 
moves over groups of characters, so even on versions of uniscribe that 
fully support Khmer fonts, the behaviour is still different than libotf.